Subject: Re: [PATCH v2 2/3] unpack-trees: increment cache_bottom for sparse directories

From: Junio C Hamano <[email-masked]>
Date: Mon, 21 Mar 2022 13:52:57 -0700

Derrick Stolee <[email-masked]> writes:

> On 3/17/2022 11:55 AM, Victoria Dye via GitGitGadget wrote:
>> From: Victoria Dye <[email-masked]>
>> 
>> Correct tracking of the 'cache_bottom' for cases where sparse directories
>> are present in the index.
>
> Thank you for the detailed background (that I cut from my reply).
>
>> CORRECTING CACHE_BOTTOM
>> -----------------------
>> The problems observed in 't1092' come from 'cache_bottom' lagging behind in
>> cases where the cache tree-based advancement doesn't occur. To solve this,
>> then, the fix in 17a1bb570b is "reversed"; rather than skipping
>> 'cache_bottom' advancement in 'mark_ce_used()', we skip the directory
>> contents-based advancement for sparse directories. Now, every index entry
>> can be accounted for in 'cache_bottom':
>
> I have sufficient background to be confident that you are doing the
> right thing here!

;-)  

The "partly lagging" walking of the index guided by cache_bottom has
been a tricky thing in the unpack_trees machinery, and I am very
happy that we now have two more experts on the topic ;-)

Thanks, both.